Prove/ThirdASPNETCore/ThirdASPNETCore/Controllers/DepartmentController.cs
using Microsoft.AspNetCore.Mvc;
using System;
using System.Linq;
using Microsoft.AspNetCore.Authorization;
using ThirdASPNETCore.Data;
using ThirdASPNETCore.Models;

namespace ThirdASPNETCore.Controllers
{
    [Authorize]
    public class DepartmentController : Controller
    {
        private readonly Repository _repository;

        public DepartmentController(Repository repository)
        {
            _repository = repository;
        }

        // GET: Department
        [Authorize(Roles = "Admin, User")]
        public ActionResult Index()
        {
            var entities = _repository.Set<Department>().ToList();
            return View(entities);
        }

        // GET: Department/Details/5
        public ActionResult Details(int id)
        {
            var entity = _repository.Set<Department>().Find(id);
            return View(entity);
        }

        // GET: Department/Create
        [Authorize(Roles = "Admin")]
        public ActionResult Create()
        {
            var entity = new Department();
            return View(entity);
        }

        // POST: Department/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Department entity)
        {
            try
            {
                if (!ModelState.IsValid) return View();
                _repository.Add(entity);
                _repository.SaveChanges();
                return RedirectToAction(nameof(Index));
            }
            catch (Exception exc)
            {
                TempData["Exception"] = exc.Message;
                return View();
            }
        }

        // GET: Department/Edit/5
        [HttpGet]
        public ActionResult Edit(int id)
        {
            var entity = _repository.Set<Department>().Find(id);
            return View(entity);
        }

        // POST: Department/Edit
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(Department entity)
        {
            try
            {
                if (!ModelState.IsValid) return View();
                _repository.Update(entity);
                _repository.SaveChanges();
                return RedirectToAction(nameof(Index));
            }
            catch (Exception exc)
            {
                TempData["Exception"] = exc.Message;
                return View();
            }
        }

        public ActionResult Delete(int id)
        {
            try
            {
                _repository.Remove(new Department {Id = id});
                _repository.SaveChanges();
            }
            catch (Exception exc)
            {
                TempData["Exception"] = exc.Message;
            }
            return RedirectToAction(nameof(Index));
        }

        //protected override void Dispose(bool disposing)
        //{
        //    if (disposing)
        //    {
        //        _repository.Dispose();
        //    }
        //    base.Dispose(disposing);
        //}
    }
}

Prove/ThirdASPNETCore/ThirdASPNETCore/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ThirdASPNETCore</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"/>
    </environment>
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">
                    ThirdASPNETCore
                    @if (User.Identity.IsAuthenticated)
                    {
                        <span>- Hi @User.Identity.Name!</span>
                    }
                </a>
                
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        @if (!User.Identity.IsAuthenticated)
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Account" asp-action="Login">Log in</a>
                            </li>
                        }
                        else
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Account" asp-action="Logout">Log out</a>
                            </li>
                            if (User.IsInRole("Admin") || User.IsInRole("User"))
                            {
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Department" asp-action="Index">Department</a>
                                </li>
                            }
                        }
                    </ul>
                </div>
            </div>
        </nav>
    </header>
<div class="container">
    <main role="main" class="pb-3">
        @if (TempData["Exception"] != null)
        {
            <div class="exception">
                <span >@TempData["Exception"]</span>
            </div>
        }
        @RenderBody()
    </main>
</div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2019 - ThirdASPNETCore
        </div>
    </footer>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-xrRywqdh3PHs8keKZN+8zzc5TX0GRTLCcmivcbNJWm2rs5C8PRhcEn3czEjhAO9o">
        </script>
    </environment>
<script src="~/js/site.js" asp-append-version="true"></script>
<partial name="_ValidationScriptsPartial"/>

    @RenderSection("Scripts", required: false)
</body>
</html>